"use client";
import { Swiper, SwiperSlide } from "swiper/react";
import { IconButton } from "@mui/material";
import { ChevronLeft, ChevronRight } from "@mui/icons-material";
import { useRef, useState } from "react";
import UserVoiceCard from "../common/cards/UserVoiceCard";
import ProductSection from "../sections/ProductSection";
const SimpleProductUserVoices = ({ hidden, section }) => {
  const audioList = section.content;

  const [currentAudio, setCurrentAudio] = useState(null); // صدای در حال پخش
  const [isPlaying, setIsPlaying] = useState(false); // وضعیت پخش
  const [loading, setLoading] = useState(false); // وضعیت لودینگ
  const [progress, setProgress] = useState(0); // پیشرفت صدا
  const [buffered, setBuffered] = useState(0); // مقدار بافر
  const [duration, setDuration] = useState(0); // مدت زمان کل
  const [currentTime, setCurrentTime] = useState(0); // زمان پخش‌شده
  const audioRef = useRef(null); // اشاره به آبجکت Audio
  const handlePlay = (audio) => {
    // اگر یک صدا در حال پخش است، آن را متوقف کن
    if (audioRef.current) {
      audioRef.current.pause();
      audioRef.current = null; // پاک کردن مرجع صدا قبلی
    }

    // ساخت یک آبجکت جدید Audio برای صدای انتخابی
    const newAudio = new Audio(audio.voiceUrl);
    audioRef.current = newAudio;
    setCurrentAudio(audio);
    setIsPlaying(true);
    setLoading(true);

    // رویداد برای وقتی که صدا بارگذاری می‌شود
    newAudio.addEventListener("loadedmetadata", () => {
      setLoading(false);
      setDuration(Math.floor(newAudio.duration)); // مدت زمان کل به ثانیه
      newAudio.play();
    });

    // رویداد برای به‌روزرسانی پراگرس بار پخش و زمان پخش‌شده
    newAudio.addEventListener("timeupdate", () => {
      setProgress((newAudio.currentTime / newAudio.duration) * 100);
      setCurrentTime(Math.floor(newAudio.currentTime)); // زمان پخش‌شده به ثانیه
    });

    // رویداد برای به‌روزرسانی بافر
    newAudio.addEventListener("progress", () => {
      if (newAudio.buffered.length > 0) {
        const bufferedEnd = newAudio.buffered.end(newAudio.buffered.length - 1);
        const bufferedPercentage = (bufferedEnd / newAudio.duration) * 100;
        setBuffered(bufferedPercentage);
      }
    });

    // رویداد پایان صدا
    newAudio.addEventListener("ended", () => {
      setIsPlaying(false);
      setProgress(0);
      setBuffered(0);
      setCurrentTime(0);
    });
  };

  const handlePause = () => {
    if (audioRef.current) {
      audioRef.current.pause();
      setIsPlaying(false);
    }
  };

  const togglePlay = (audio) => {
    if (currentAudio && currentAudio.id === audio.id && isPlaying) {
      handlePause();
    } else {
      handlePlay(audio);
    }
  };

  //* swiper controller
  const swiperRef = useRef(null);
  const [isBeginning, setIsBeginning] = useState(true);
  const [isEnd, setIsEnd] = useState(false);

  const handleNext = () => {
    if (swiperRef.current && !isEnd) {
      swiperRef.current.swiper.slideNext();
    }
  };

  const handlePrev = () => {
    if (swiperRef.current && !isBeginning) {
      swiperRef.current.swiper.slidePrev();
    }
  };

  const handleSlideChange = (swiper) => {
    setIsBeginning(swiper.isBeginning);
    setIsEnd(swiper.isEnd);
  };
  return (
    <ProductSection hidden={hidden} section={section}>
      {/* <div className="item-grid w-full">
        <Swiper
          ref={swiperRef}
          onSlideChange={handleSlideChange}
          direction="horizontal"
          spaceBetween={16}
          style={{ width: "100%", maxWidth: "100%" }}
          slidesPerView={"auto"}
        >
          {audioList.map((audio, index) => (
            <SwiperSlide
              key={index.toString()}
              style={{
                width: "294px",
                height: "108px",
                padding: "2px",
                boxSizing: "border-box",
              }}
            >
              <UserVoiceCard
                item={audio}
                number={index + 1}
                togglePlay={() => togglePlay(audio)}
                isLoading={
                  loading && currentAudio && currentAudio.id === audio.id
                }
                progress={
                  progress && currentAudio && currentAudio.id === audio.id
                    ? progress
                    : 0
                }
                buttonStatus={
                  currentAudio && currentAudio.id === audio.id && isPlaying
                    ? "Pause"
                    : "Play"
                }
                buffered={
                  buffered && currentAudio && currentAudio.id === audio.id
                    ? buffered
                    : 0
                }
                duration={
                  duration && currentAudio && currentAudio.id === audio.id
                    ? duration
                    : 0
                }
                currentTime={
                  currentTime && currentAudio && currentAudio.id === audio.id
                    ? currentTime
                    : 0
                }
              />
            </SwiperSlide>
          ))}
        </Swiper>
      </div>
      <div className="w-full flex items-center justify-between">
        <IconButton disabled={isBeginning} onClick={handlePrev}>
          <ChevronRight />
        </IconButton>

        <IconButton onClick={handleNext} disabled={isEnd}>
          <ChevronLeft />
        </IconButton>
      </div> */}
    </ProductSection>
  );
};

export default SimpleProductUserVoices;
